using System;
using System.Drawing;
using System.Collections.Generic;

using Physics.Entities;
using Physics.Entities.Physics;

namespace Physics
{
    class GravityWell : PhysicsEffect
    {
        private Vector2 Position;

        public GravityWell(Vector2 position)
        {
            Position = position;
        }
        public GravityWell(Point position)
        {
            Position = new Vector2(position);
        }

        public void ApplyEffect(PhysicsE E)
        {
            if (E.affectedby.GravityWell && !E.affectedby.Ignored(this))
            {
                float dist = (Position - E.Position).Length;
                if (dist > 0.5F || dist < -0.5F)
                    E.ApplyForce((Position - E.Position) / dist / dist * E.Mass * 10);
            }
        }

        public void ApplyEffect(Entity E)
        {
            if (E is PhysicsE)
                ApplyEffect((PhysicsE)E);
        }
    }
}
