using System;
using System.Collections.Generic;
using System.Text;

using Physics.Entities;
using Physics.Entities.Physics;

namespace Physics
{
    class MouseWind : PhysicsEffect
    {
        public Vector2 fromPosition
        {
            get
            {
                return from.Clone();
            }
        }

        Vector2 from;
        Vector2 to;

        public float AirViscosity = 0.00002F;

        public MouseWind(Vector2 fromPosition)
        {
            from = fromPosition.Clone();
        }
        public MouseWind()
        {
            Zero();
        }
        public void UpdateTo(Vector2 toPosition)
        {
            to = toPosition.Clone();
        }
        public void Zero()
        {
            to = null;
            from = null;
        }

        public void ApplyEffect(PhysicsE E)
        {
            if (E.affectedby.MouseWind && !E.affectedby.Ignored(this))
            {
                if (E is Ball)
                {
                    Ball B = (Ball)E;
                    B.ApplyForce(-6 * (float)Math.PI * B.Radius * AirViscosity * (B.Velocity - getVelocity()));
                }
            }
        }

        public void ApplyEffect(Entity E)
        {
            if (E is PhysicsE)
            {
                ApplyEffect((PhysicsE)E);
                return;
            }


            if (E.affectedby.MouseWind && !E.affectedby.Ignored(this))
                E.Velocity = getVelocity();
        }

        private Vector2 getVelocity()
        {
            if (to == null || from == null)
                return new Vector2(0, 0);
            else
                return (to - from) / 10;
        }
    }
}
