using SdlDotNet;

namespace Physics.Entities
{
    abstract class Entity
    {
        // each Entity needs a position and velocity
        public Vector2 Position; // should always be set on creation
        protected Vector2 Velo = new Vector2(0, 0);

        public Vector2 Velocity
        { 
            get { return Velo; }
            set { Velo = value; } 
        }

        public EffectBools affectedby = new EffectBools(false);

        public abstract void Update(float timeStep);
        public abstract void Draw(Surface target);
    }
}
