using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Physics.Entities.Particles
{
    class WindParticle : PointP
    {
        public WindParticle(Vector2 position, int lifeTime) : base(position, lifeTime)
        {
            radius = 2;
            color = Color.DarkSeaGreen;

            affectedby.MouseWind = true;
        }

        public override void Update(float timeStep)
        {
            Position.X = (Position.X) % Game.videoSize.X;
            if (Position.X < 0)
                Position.X += Game.videoSize.X;

            Position.Y = (Position.Y) % Game.videoSize.Y;
            if (Position.Y < 0)
                Position.Y += Game.videoSize.Y;

            base.Update(timeStep);
        }
        public override void Draw(SdlDotNet.Surface target)
        {
            base.Draw(target);
        }
    }
}
