using System;
using System.Drawing;
using SdlDotNet;

namespace Physics.Entities.Physics
{
    class Ball: PhysicsE
    {
        public short Radius = 20;
        public Color color = Color.Blue;
        public Color CrossColor = Color.Pink;

        // a quick addition of very basic rotation
        // polygon basic rotation needs work
        public bool Rotates = false;

        public override float RMass
        {
            get
            {
                return Mass * Radius * Radius / 2;
            }
        }

        public override void Update(float timeStep)
        {
            base.Update(timeStep);                
        }

        public Ball(Vector2 position)
        {
            Position = position.Clone();
            affectedby = new EffectBools(true);
        }

        public override void Draw(Surface target)
        {
            target.DrawFilledCircle(new Circle(Position.Point, Radius), color);

            if (antiAliasingOn) // apply some anti-aliasing if true
                target.DrawCircle(new Circle(Position.Point, Radius), color, true);

            if (Rotates)
                DrawCross(target);
        }
        private void DrawCross(Surface target)
        {
            // draws a cross on the balls so we can tell they are rotating
            Vector2 V1 = new Vector2(Radius, 0);
            V1.Rotate(Rotation);
            Vector2 V2 = new Vector2(-Radius, 0);
            V2.Rotate(Rotation);
            target.DrawLine(new Line((V1 + Position).Point,
                                     (V2 + Position).Point), CrossColor, true);

            Vector2 V3 = new Vector2(0, Radius);
            V3.Rotate(Rotation);
            Vector2 V4 = new Vector2(0, -Radius);
            V4.Rotate(Rotation);
            target.DrawLine(new Line((V3 + Position).Point,
                                     (V4 + Position).Point), CrossColor, true);
        }
    }
}
