using System;
using SdlDotNet;

using Physics.Config.Files;

namespace Physics.States
{
    abstract class GameState
    {
        protected States_cfg cfg = new States_cfg();

        public abstract void Input(bool onTop);

        // final / sealed?
        public void Update(float timeStep)
        {
            Update(timeStep, false);
        }
        public abstract void Update(float timeStep, bool onTop);

        public abstract void Draw(Surface target, bool onTop);
    }
}
