using System;
using System.Drawing;
using SdlDotNet;

namespace Physics.States
{
    class Paused : GameState
    {
        // The font used for rendering text in the game
        static SdlDotNet.Font pausedFont = new SdlDotNet.Font("FreeSans.ttf", 100);

        public override void Input(bool onTop)
        {
            if (onTop && cfg.pause.wasPressed())
                Game.RemoveGameState(this);
        }

        public override void Update(float timeStep, bool onTop)
        {

        }

        public override void Draw(Surface target, bool onTop)
        {
            Surface temp = new Surface(target.Size);
            temp.Fill(Color.Gray);
            temp.AlphaBlending = true;
            temp.Alpha = 100;

            target.Blit(temp, new Point(0, 0));
            temp.Dispose();

            Surface temp2 = pausedFont.Render("PAUSED", Color.Gold, true);

            int X = (target.Width - temp2.Width) / 2;
            int Y = (target.Height - temp2.Height) / 2;
            target.Blit(temp2, new Point(X, Y));
            temp2.Dispose();
        }
    }
}
